from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="PkgRoutesPackagesRetirementCensusRecalculateCensusRequest")


@_attrs_define
class PkgRoutesPackagesRetirementCensusRecalculateCensusRequest:
    """
    Attributes:
        client (str | Unset):
        employee (str | Unset): Optional field
        reset (bool | Unset):
        return_plan_year (int | Unset): If set, returns the census for the specified plan year
        scrub (bool | Unset):
    """

    client: str | Unset = UNSET
    employee: str | Unset = UNSET
    reset: bool | Unset = UNSET
    return_plan_year: int | Unset = UNSET
    scrub: bool | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        client = self.client

        employee = self.employee

        reset = self.reset

        return_plan_year = self.return_plan_year

        scrub = self.scrub

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if client is not UNSET:
            field_dict["client"] = client
        if employee is not UNSET:
            field_dict["employee"] = employee
        if reset is not UNSET:
            field_dict["reset"] = reset
        if return_plan_year is not UNSET:
            field_dict["return_plan_year"] = return_plan_year
        if scrub is not UNSET:
            field_dict["scrub"] = scrub

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        client = d.pop("client", UNSET)

        employee = d.pop("employee", UNSET)

        reset = d.pop("reset", UNSET)

        return_plan_year = d.pop("return_plan_year", UNSET)

        scrub = d.pop("scrub", UNSET)

        pkg_routes_packages_retirement_census_recalculate_census_request = cls(
            client=client,
            employee=employee,
            reset=reset,
            return_plan_year=return_plan_year,
            scrub=scrub,
        )

        pkg_routes_packages_retirement_census_recalculate_census_request.additional_properties = d
        return pkg_routes_packages_retirement_census_recalculate_census_request

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
